"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var MongooseCrudModule_1;
Object.defineProperty(exports, "__esModule", { value: true });
exports.MongooseCrudModule = void 0;
const common_1 = require("@nestjs/common");
const injection_tokens_1 = require("./consts/injection-tokens");
const query_service_1 = require("./services/query.service");
let MongooseCrudModule = MongooseCrudModule_1 = class MongooseCrudModule {
    static forFeature(options) {
        return MongooseCrudModule_1.initialize(false, MongooseCrudModule_1.syncProvider(options));
    }
    static forRoot(options) {
        return MongooseCrudModule_1.initialize(true, MongooseCrudModule_1.syncProvider(options));
    }
    static forFeatureAsync(options) {
        return MongooseCrudModule_1.initialize(false, MongooseCrudModule_1.asyncProvider(options));
    }
    static forRootAsync(options) {
        return MongooseCrudModule_1.initialize(true, MongooseCrudModule_1.asyncProvider(options));
    }
    static syncProvider(options) {
        return {
            provide: injection_tokens_1.MONGOOSE_CRUD_OPTIONS,
            useValue: options
        };
    }
    static asyncProvider(options) {
        return {
            provide: injection_tokens_1.MONGOOSE_CRUD_OPTIONS,
            useFactory: options.useFactory,
            inject: options.inject
        };
    }
    static initialize(global, optionsProvider) {
        return {
            module: MongooseCrudModule_1,
            providers: [
                optionsProvider,
                query_service_1.QueryService
            ],
            exports: [
                query_service_1.QueryService
            ],
            global
        };
    }
};
exports.MongooseCrudModule = MongooseCrudModule;
exports.MongooseCrudModule = MongooseCrudModule = MongooseCrudModule_1 = __decorate([
    (0, common_1.Module)({})
], MongooseCrudModule);
