import { MigrationWrapper } from "../types/migrations";
import { Logger } from "@nestjs/common";
import { Connection, Model } from "mongoose";
import { ChangelogLockDocument } from "../schemas/changelog-lock.schema";
import { ChangelogDocument } from "../schemas/changelog.schema";
/**
 * Used internally by the migration mechanism, for use only in `main.ts`.
 */
export declare class MigrateService {
    readonly connection: Connection;
    readonly migrations: MigrationWrapper[];
    private readonly changelogModel;
    private readonly changelogLockModel;
    static readonly MIGRATIONS = "MONGO_MIGRATIONS";
    readonly logger: Logger;
    constructor(connection: Connection, migrations: MigrationWrapper[], changelogModel: Model<ChangelogDocument>, changelogLockModel: Model<ChangelogLockDocument>);
    acquireLock(): Promise<boolean>;
    releaseLock(): Promise<boolean>;
    logMigration(migration: MigrationWrapper): Promise<void>;
    getChangelog(): Promise<ChangelogDocument[]>;
    private lockData;
}
