import { QueryData, QueryResult } from '@jchpro/nest-common';
import { Document, Model, ProjectionType } from 'mongoose';
import { CrudOptions, FilterQueryProvider } from '../types/crud';
import { OtherQueryOptions, QueryExecutor } from './query.executor';
export declare class QueryService {
    private readonly crudOptions?;
    constructor(crudOptions?: CrudOptions | undefined);
    prepare<TDoc extends Document, TRaw = any>(model: Model<TDoc>, data: QueryData, filtersProvider?: FilterQueryProvider<TRaw>, project?: ProjectionType<TRaw>, other?: OtherQueryOptions): QueryExecutor<TDoc, TRaw>;
    execute<TDoc extends Document, TRaw = any>(model: Model<TDoc>, data: QueryData, filtersProvider?: FilterQueryProvider<TRaw>, project?: ProjectionType<TRaw>, other?: OtherQueryOptions): Promise<QueryResult<TDoc>>;
}
