"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.QueryService = void 0;
const common_1 = require("@nestjs/common");
const injection_tokens_1 = require("../consts/injection-tokens");
const query_executor_1 = require("./query.executor");
let QueryService = class QueryService {
    constructor(crudOptions) {
        this.crudOptions = crudOptions;
    }
    prepare(model, data, filtersProvider, project, other) {
        return new query_executor_1.QueryExecutor(model, data, {
            filtersProvider,
            project,
            crud: this.crudOptions,
            other
        });
    }
    execute(model, data, filtersProvider, project, other) {
        return this.prepare(model, data, filtersProvider, project, other)
            .execute();
    }
};
exports.QueryService = QueryService;
exports.QueryService = QueryService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, common_1.Inject)(injection_tokens_1.MONGOOSE_CRUD_OPTIONS)),
    __metadata("design:paramtypes", [Object])
], QueryService);
